package de.brightbyte.wikiword.builder;

import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Map;

public class MapBench {
	protected static final int M = 1024 * 1024;
	
	protected static void blubb(int i, long c, long baseline) {
		System.out.println(" == "+i);
		
		long f = Runtime.getRuntime().freeMemory();
		long t = Runtime.getRuntime().totalMemory();
		long x = Runtime.getRuntime().maxMemory();
		long u = (t-f) - baseline;
		System.out.println("    "+u/M+"M + "+baseline/M+"M / "+t/M+"M / "+x/M+"M");
		
		i+= 1;
		System.out.println("    ~"+(u/i)+" bytes/entry, "+(c/i)+" avg name length; overhead ~ "+((u/i)-(c/i))+" bytes");
	}
	
	public static void main(String[] args) throws UnsupportedEncodingException {
		int max = 10 * 1000 * 1000;
		int chunk = 1000 * 1000;
		
		long chars = 0;
		
		String prefix = "TESING-ABCDEF-";
		
		Map<String, Integer> m = new HashMap<String, Integer>();
		long baseline = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
		
		int i=0;
		for (; i<max; i++) {
			String n = prefix + i;
			m.put(n, i);
			chars += n.length();
			
			if (i%chunk == 0) {
				blubb(i, chars, baseline);
			}
		}

		blubb(i, chars, baseline);
	}
}
